//def factorial(fact : Int, number : Int) : Int = {
//  if (number == 1)
//    fact
//  else
//    factorial(fact * number, number - 1)
//}
//
//println(factorial(1, 5))

//def factorialImp(fact : Int, number : Int) : Int = {
//  if (number == 1)
//    fact
//  else
//    factorialImp(fact * number, number - 1)
//}
//
//def factorial(number : Int) = factorialImp(1, number)
//
//println(factorial(5))

def factorial(number : Int) = {
  @scala.annotation.tailrec
  def factorialImp(fact : Int, number : Int) : Int = {
    if (number == 1)
      fact
    else
      factorialImp(fact * number, number - 1)
  }


  factorialImp(1, number)
}

println(factorial(5))
