trait Friend {
  val name : String
  def listen = println(name + " is listening... ")  
}

class Human(val name : String) extends Friend
def seekHelpFrom(friend : Friend) = friend.listen

class Animal(val name : String)
class Dog(override val name : String) extends
  Animal(name) with Friend

val daniel = new Human("Daniel")
daniel.listen
seekHelpFrom(daniel)

val buddy = new Dog("Buddy")
buddy.listen
seekHelpFrom(buddy)

class Cat(override val name : String) extends Animal(name)

//val alf = new Cat("Alf")
//alf.listen


val seraphina = new Cat("Seraphina") with Friend
seraphina.listen







