val numbers = List(1, 2, 3, 4, 5)

var total1 = 0
for(i <- numbers) {
  total1 += i
}
println("Total is " + total1)

val total2 = numbers.foldLeft(0) { (carry, e) => carry + e }
println("Total is " + total2)

val total3 = (0 /: numbers) { (carry, e) => carry + e }
println("Total is " + total3)

val total4 = (0 /: numbers) { _ + _ }
println("Total is " + total4)

def add(op1 : Int, op2 : Int) = op1 + op2
val total5 = (0 /: numbers) { add }
println("Total is " + total5)

val minusOne = numbers map { _ - 1 }
println(minusOne)









